package com.nemoquiz.backendlesstest;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import com.backendless.Backendless;
import com.backendless.BackendlessCollection;
import com.backendless.async.callback.BackendlessCallback;
import com.backendless.persistence.BackendlessDataQuery;

import java.util.List;

public class MainActivity extends AppCompatActivity {
    EditText mComment;
    Button bSubmit;
    EditText etSearch;
    Button bSearch;
    TextView status;
    Comment newComment;
    BackendlessDataQuery pageQuery;
    BackendlessCollection commentsCollection;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //Paste your own app's ID and secret key below from backendless.com Manage menu
        String appID = "36B067E1-F470-1927-FFE8-C99EF45CAA00";
        String secretKey = "F7BB64E5-A989-521A-FFF1-3C6921C45400";
        Backendless.initApp(this,appID,secretKey,"v1");

        mComment = (EditText) findViewById(R.id.etComment);
        bSubmit = (Button) findViewById(R.id.bSubmit);
        etSearch = (EditText) findViewById(R.id.etSearch);
        bSearch = (Button) findViewById(R.id.bSearch);
        status = (TextView) findViewById(R.id.status);

        pageQuery = new BackendlessDataQuery();
        pageQuery.setPageSize(5);

        bSubmit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                status.setText("Saving data to Backendless...");
                newComment = new Comment();
                newComment.setMessage(mComment.getText().toString());

                Backendless.Persistence.save(newComment, new BackendlessCallback<Comment>() {
                    @Override
                    public void handleResponse(Comment comment) {
                        status.setText("New comment saved: "+comment.getMessage());
                        mComment.setText("");
                    }
                });
            }
        });

        bSearch.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                status.setText("Searching for "+etSearch.getText().toString()+"...");
                String whereClause = "message LIKE '%"+etSearch.getText().toString()+"%'";
                BackendlessDataQuery dataQuery = new BackendlessDataQuery();
                dataQuery.setWhereClause(whereClause);
                dataQuery.setPageSize(20);
                Backendless.Persistence.of(Comment.class).find(dataQuery, new BackendlessCallback<BackendlessCollection<Comment>>() {
                    @Override
                    public void handleResponse(BackendlessCollection<Comment> response) {
                        List<Comment> comments = response.getData();
                        String statusText = "";
                        if(comments.size()==0){
                            statusText = "No records containing '"+etSearch.getText().toString()+"' were found.";
                        }
                        else {
                            for (int i = 0; i < comments.size(); i++) {
                                statusText += comments.get(i).getMessage() + "\n";
                            }
                        }
                        status.setText(statusText);
                        etSearch.setText("");
                    }
                });
            }
        });

    }
}